<template>
  <li class="cart__item product">
    <div class="product__pic">
      <img :src="data.image" width="120" height="120"
           alt="Название товара">
    </div>
    <h3 class="product__title">
      {{ data.name }}
    </h3>
    <p class="product__info">
      Объем: <span>128GB</span>
    </p>
    <span class="product__code">
                Артикул: {{ data.id }}
                </span>

    <QuantityChoser :quantity.sync="quantity" />

    <b class="product__price">
      {{ data.price | beautifyNumber }} ₽
    </b>

    <button class="product__del button-del" type="button"
            @click.prevent="removeItemFromCart({itemId: data.id})"
            aria-label="Удалить товар из корзины">
      <svg width="20" height="20" fill="currentColor">
        <use xlink:href="#icon-close"></use>
      </svg>
    </button>
  </li>
</template>

<script>
import beautifyNumber from '@/helpers/beautifyNumber';
import { mapMutations } from 'vuex';
import QuantityChoser from '@/components/helpers/QuantityChoser.vue';

export default {
  name: 'itemInCart',
  components: { QuantityChoser },
  props: ['data'],
  computed: {
    quantity: {
      get() {
        return this.data.quantity;
      },
      set(value) {
        this.changeQuantity(
          {
            itemId: this.data.id,
            quantity: value,
          },
        );
      },
    },
  },
  filters: {
    beautifyNumber,
  },
  methods: {
    ...mapMutations([
      'changeQuantity',
      'removeItemFromCart',
    ]),
  },
};
</script>

<style scoped>

</style>
